# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, Dict, List, Optional

from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist


class CreateProductRequest(BaseModel):
  """
    CreateProductRequest
    """
  name: StrictStr = Field(..., description='Name of product.')
  description: StrictStr = Field(..., description="Product's description.")
  account_sku: Optional[StrictStr] = None
  features: Optional[conlist(StrictStr)] = None
  unit_label: Optional[StrictStr] = None
  is_active: Optional[StrictBool] = Field(
    True, description='Whether or not this product is accepting new subscriptions.'
  )
  custom_fields: Optional[Dict[str, Any]] = None
  __properties = [
    'name', 'description', 'account_sku', 'features', 'unit_label', 'is_active', 'custom_fields'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateProductRequest:
    """Create an instance of CreateProductRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if account_sku (nullable) is None
    # and __fields_set__ contains the field
    if self.account_sku is None and 'account_sku' in self.__fields_set__:
      _dict['account_sku'] = None

    # set to None if unit_label (nullable) is None
    # and __fields_set__ contains the field
    if self.unit_label is None and 'unit_label' in self.__fields_set__:
      _dict['unit_label'] = None

    # set to None if custom_fields (nullable) is None
    # and __fields_set__ contains the field
    if self.custom_fields is None and 'custom_fields' in self.__fields_set__:
      _dict['custom_fields'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateProductRequest:
    """Create an instance of CreateProductRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateProductRequest.parse_obj(obj)

    _obj = CreateProductRequest.parse_obj(
      {
        'name': obj.get('name'),
        'description': obj.get('description'),
        'account_sku': obj.get('account_sku'),
        'features': obj.get('features'),
        'unit_label': obj.get('unit_label'),
        'is_active': obj.get('is_active') if obj.get('is_active') is not None else True,
        'custom_fields': obj.get('custom_fields')
      }
    )
    return _obj
