# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import List, Optional

from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.date_time_filter import DateTimeFilter
from getopenpay.models.price_type_enum import PriceTypeEnum
from pydantic import BaseModel, Field, StrictBool, StrictStr, conint, conlist


class PriceQueryParams(BaseModel):
  """
    PriceQueryParams
    """
  page_number: Optional[conint(strict=True, ge=1)] = Field(1, description='Page number')
  page_size: Optional[conint(strict=True, le=100, ge=1)] = Field(100, description='Page size')
  sort_key: Optional[StrictStr] = Field(
    'created_at', description='Key name based on which data is sorted.'
  )
  sort_descending: Optional[StrictBool] = Field(False, description='Sort direction.')
  created_at: Optional[DateTimeFilter] = None
  updated_at: Optional[DateTimeFilter] = None
  expand: Optional[conlist(StrictStr)] = None
  product_id: Optional[StrictStr] = None
  is_active: Optional[StrictBool] = None
  currency: Optional[CurrencyEnum] = None
  price_type: Optional[PriceTypeEnum] = None
  __properties = [
    'page_number', 'page_size', 'sort_key', 'sort_descending', 'created_at', 'updated_at', 'expand',
    'product_id', 'is_active', 'currency', 'price_type'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> PriceQueryParams:
    """Create an instance of PriceQueryParams from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of created_at
    if self.created_at:
      _dict['created_at'] = self.created_at.to_dict()
    # override the default output from pydantic by calling `to_dict()` of updated_at
    if self.updated_at:
      _dict['updated_at'] = self.updated_at.to_dict()
    # set to None if created_at (nullable) is None
    # and __fields_set__ contains the field
    if self.created_at is None and 'created_at' in self.__fields_set__:
      _dict['created_at'] = None

    # set to None if updated_at (nullable) is None
    # and __fields_set__ contains the field
    if self.updated_at is None and 'updated_at' in self.__fields_set__:
      _dict['updated_at'] = None

    # set to None if product_id (nullable) is None
    # and __fields_set__ contains the field
    if self.product_id is None and 'product_id' in self.__fields_set__:
      _dict['product_id'] = None

    # set to None if is_active (nullable) is None
    # and __fields_set__ contains the field
    if self.is_active is None and 'is_active' in self.__fields_set__:
      _dict['is_active'] = None

    # set to None if currency (nullable) is None
    # and __fields_set__ contains the field
    if self.currency is None and 'currency' in self.__fields_set__:
      _dict['currency'] = None

    # set to None if price_type (nullable) is None
    # and __fields_set__ contains the field
    if self.price_type is None and 'price_type' in self.__fields_set__:
      _dict['price_type'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> PriceQueryParams:
    """Create an instance of PriceQueryParams from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return PriceQueryParams.parse_obj(obj)

    _obj = PriceQueryParams.parse_obj(
      {
        'page_number': obj.get('page_number') if obj.get('page_number') is not None else 1,
        'page_size': obj.get('page_size') if obj.get('page_size') is not None else 100,
        'sort_key': obj.get('sort_key') if obj.get('sort_key') is not None else 'created_at',
        'sort_descending':
          obj.get('sort_descending') if obj.get('sort_descending') is not None else False,
        'created_at':
          DateTimeFilter.from_dict(obj.get('created_at'))
          if obj.get('created_at') is not None else None,
        'updated_at':
          DateTimeFilter.from_dict(obj.get('updated_at'))
          if obj.get('updated_at') is not None else None,
        'expand': obj.get('expand'),
        'product_id': obj.get('product_id'),
        'is_active': obj.get('is_active'),
        'currency': obj.get('currency'),
        'price_type': obj.get('price_type')
      }
    )
    return _obj
