# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import List, Optional

from getopenpay.models.date_time_filter import DateTimeFilter
from getopenpay.models.search_filter import SearchFilter
from getopenpay.models.subscription_status_enum import SubscriptionStatusEnum
from pydantic import BaseModel, Field, StrictBool, StrictStr, conint, conlist


class SubscriptionQueryParams(BaseModel):
  """
    SubscriptionQueryParams
    """
  page_number: Optional[conint(strict=True, ge=1)] = Field(1, description='Page number')
  page_size: Optional[conint(strict=True, le=100, ge=1)] = Field(100, description='Page size')
  sort_key: Optional[StrictStr] = Field(
    'created_at', description='Key name based on which data is sorted.'
  )
  sort_descending: Optional[StrictBool] = Field(False, description='Sort direction.')
  created_at: Optional[DateTimeFilter] = None
  updated_at: Optional[DateTimeFilter] = None
  expand: Optional[conlist(StrictStr)] = None
  customer_id: Optional[StrictStr] = None
  product_id: Optional[StrictStr] = None
  price_id: Optional[StrictStr] = None
  status: Optional[SubscriptionStatusEnum] = None
  current_period_start: Optional[DateTimeFilter] = None
  current_period_end: Optional[DateTimeFilter] = None
  coupon_id: Optional[StrictStr] = None
  search: Optional[SearchFilter] = None
  __properties = [
    'page_number', 'page_size', 'sort_key', 'sort_descending', 'created_at', 'updated_at', 'expand',
    'customer_id', 'product_id', 'price_id', 'status', 'current_period_start', 'current_period_end',
    'coupon_id', 'search'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> SubscriptionQueryParams:
    """Create an instance of SubscriptionQueryParams from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of created_at
    if self.created_at:
      _dict['created_at'] = self.created_at.to_dict()
    # override the default output from pydantic by calling `to_dict()` of updated_at
    if self.updated_at:
      _dict['updated_at'] = self.updated_at.to_dict()
    # override the default output from pydantic by calling `to_dict()` of current_period_start
    if self.current_period_start:
      _dict['current_period_start'] = self.current_period_start.to_dict()
    # override the default output from pydantic by calling `to_dict()` of current_period_end
    if self.current_period_end:
      _dict['current_period_end'] = self.current_period_end.to_dict()
    # override the default output from pydantic by calling `to_dict()` of search
    if self.search:
      _dict['search'] = self.search.to_dict()
    # set to None if created_at (nullable) is None
    # and __fields_set__ contains the field
    if self.created_at is None and 'created_at' in self.__fields_set__:
      _dict['created_at'] = None

    # set to None if updated_at (nullable) is None
    # and __fields_set__ contains the field
    if self.updated_at is None and 'updated_at' in self.__fields_set__:
      _dict['updated_at'] = None

    # set to None if customer_id (nullable) is None
    # and __fields_set__ contains the field
    if self.customer_id is None and 'customer_id' in self.__fields_set__:
      _dict['customer_id'] = None

    # set to None if product_id (nullable) is None
    # and __fields_set__ contains the field
    if self.product_id is None and 'product_id' in self.__fields_set__:
      _dict['product_id'] = None

    # set to None if price_id (nullable) is None
    # and __fields_set__ contains the field
    if self.price_id is None and 'price_id' in self.__fields_set__:
      _dict['price_id'] = None

    # set to None if status (nullable) is None
    # and __fields_set__ contains the field
    if self.status is None and 'status' in self.__fields_set__:
      _dict['status'] = None

    # set to None if current_period_start (nullable) is None
    # and __fields_set__ contains the field
    if self.current_period_start is None and 'current_period_start' in self.__fields_set__:
      _dict['current_period_start'] = None

    # set to None if current_period_end (nullable) is None
    # and __fields_set__ contains the field
    if self.current_period_end is None and 'current_period_end' in self.__fields_set__:
      _dict['current_period_end'] = None

    # set to None if coupon_id (nullable) is None
    # and __fields_set__ contains the field
    if self.coupon_id is None and 'coupon_id' in self.__fields_set__:
      _dict['coupon_id'] = None

    # set to None if search (nullable) is None
    # and __fields_set__ contains the field
    if self.search is None and 'search' in self.__fields_set__:
      _dict['search'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> SubscriptionQueryParams:
    """Create an instance of SubscriptionQueryParams from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return SubscriptionQueryParams.parse_obj(obj)

    _obj = SubscriptionQueryParams.parse_obj(
      {
        'page_number': obj.get('page_number') if obj.get('page_number') is not None else 1,
        'page_size': obj.get('page_size') if obj.get('page_size') is not None else 100,
        'sort_key': obj.get('sort_key') if obj.get('sort_key') is not None else 'created_at',
        'sort_descending':
          obj.get('sort_descending') if obj.get('sort_descending') is not None else False,
        'created_at':
          DateTimeFilter.from_dict(obj.get('created_at'))
          if obj.get('created_at') is not None else None,
        'updated_at':
          DateTimeFilter.from_dict(obj.get('updated_at'))
          if obj.get('updated_at') is not None else None,
        'expand': obj.get('expand'),
        'customer_id': obj.get('customer_id'),
        'product_id': obj.get('product_id'),
        'price_id': obj.get('price_id'),
        'status': obj.get('status'),
        'current_period_start':
          DateTimeFilter.from_dict(obj.get('current_period_start'))
          if obj.get('current_period_start') is not None else None,
        'current_period_end':
          DateTimeFilter.from_dict(obj.get('current_period_end'))
          if obj.get('current_period_end') is not None else None,
        'coupon_id': obj.get('coupon_id'),
        'search':
          SearchFilter.from_dict(obj.get('search')) if obj.get('search') is not None else None
      }
    )
    return _obj
